( function ( $ ) {

	function getCookie( cname ) {
		let name = cname + '=';
		let decodedCookie = decodeURIComponent( document.cookie );
		let ca = decodedCookie.split( ';' );
		for ( let i = 0; i < ca.length; i++ ) {
			let c = ca[ i ];
			while ( c.charAt( 0 ) == ' ' ) {
				c = c.substring( 1 );
			}
			if ( c.indexOf( name ) == 0 ) {
				return c.substring( name.length, c.length );
			}
		}
		return false;
	}

	let prefersDark = false;

	if ( grimlockDarkMode && grimlockDarkMode.autodetect && window && window.matchMedia && '' !== getCookie( 'grimlock_dark_mode' ) ) {
		prefersDark = window.matchMedia( '(prefers-color-scheme: dark)' ).matches;
		document.cookie = `grimlock_dark_mode=${ prefersDark || '' }; expires=Fri, 31 Dec 9999 23:59:59 GMT; path=/`;
	}

	$( function () {
		const $body = $( 'body' );
		const $darkModeButton = $( 'button.grimlock-dark-mode__toggle' );

		if ( prefersDark ) {
			$body.addClass( 'grimlock-dark-mode--on' );
		}

		$darkModeButton.on( 'click', function () {
			$body.toggleClass( 'grimlock-dark-mode--on' );
			const isDarkMode = $body.hasClass( 'grimlock-dark-mode--on' );
			document.cookie = `grimlock_dark_mode=${ isDarkMode || '' }; expires=Fri, 31 Dec 9999 23:59:59 GMT; path=/`;
		} );
	} );

} )( jQuery );
